/*
 * crt0.S -- startup file for PowerPC systems.
 *
 * Copyright (c) 1995 Cygnus Support
 *
 * The authors hereby grant permission to use, copy, modify, distribute,
 * and license this software and its documentation for any purpose, provided
 * that existing copyright notices are retained in all copies and that this
 * notice is included verbatim in any distributions. No written agreement,
 * license, or royalty fee is required for any of the authorized uses.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 */

#include "ppc-asm.h"

	.file	"madd555crt0.S"
	.text
.Lptr:
	.globl	_start
	.type	_start,@function
_start:

/* Because we want to put our stack into DPTRAM which must be configured by 
   a C-function before it can be used, we use an initial stack in internal RAM
   to call the dptram setup function using normal calling conventions, then
   setup the real stack, then execute the program */

     /* Setup temporary stack */
	lis	sp,_init_stack_top@h         /* load the stack address as a linker defined constant */
	ori	sp,sp,_init_stack_top@l

	addi	sp,sp,-4		/* make sure we don't overwrite debug mem */
	lis	r0,0
	stw	r0,0(sp)		/* clear back chain */
	stwu	sp,-64(sp)		/* push another stack frame */
	
     /* Configure DPTRAM */
	bl	FUNC_NAME(configure_dptram)

     /* Setup real stack and begin actual execution */
	lis	sp,_stack_top@h         /* load the stack address as a linker defined constant */
	ori	sp,sp,_stack_top@l

	addi	sp,sp,-4		/* make sure we don't overwrite debug mem */
	lis	r0,0
	stw	r0,0(sp)		/* clear back chain */
	stwu	sp,-64(sp)		/* push another stack frame */
	
	/* Let her rip */
	bl	FUNC_NAME(main)

	/* return value from main is argument to exit */
	bl	FUNC_NAME(exit)
	trap
