
#include <Motorola/mpc555.h>
#include <madd-555/madd-555_hw.h>
#include <serial.h>
#include <mpc5xx/memutils.h>
#include "target_hw.h"

void (*machine_check_interrupt_routine)();
void (*external_interrupt_routine)();
void (*decrementer_interrupt_routine)();
void (*trace_interrupt_routine)();

void init_hw()
{
  mpc555_init();

  configure_dptram();  //necessary b/c our data section is there!
  initialize_data_section();    // finish C runtime memory setup
  clear_bss_section();

  machine_check_interrupt_routine = null_interrupt_handler;
  external_interrupt_routine = null_interrupt_handler;
  decrementer_interrupt_routine = null_interrupt_handler;
  trace_interrupt_routine = null_interrupt_handler;


  mpc555_init_serial(0); //initialize QSMCM SCI 1
  mpc555_init_serial(1); //initialize QSMCM SCI 2

  serial_defqsmcm = &QSMCM; //Use the only QSMCM the 555 has
  serial_defsci = 0; //Use port SCI1

}

//A default handler for every interrupt... just do nothing
void null_interrupt_handler() {
  return; //do nothing!
}


