/*
 * $Id: exception_table.s,v 1.1 2005/06/06 18:23:45 mdille3 Exp $
 *
 * exception_table.S : MPC566 low memory image	 		
 */
	
#include "ppc-asm.h"

	.file	"exception_table.S"
	.section .text

	/* Stack Frame Definition */
        .equ    XR1,0
        .equ    XBLK,XR1+4
        .equ    XR0,XBLK+4
        .equ    XSRR0,XR0+4
        .equ    XSRR1,XSRR0+4
        .equ    XCTR,XSRR1+4
        .equ    XXER,XCTR+4
        .equ    XCR,XXER+4
        .equ    XLR,XCR+4
        .equ    XR2,XLR+4
        .equ    XR3,XR2+4
        .equ    XR4,XR3+4
        .equ    XR5,XR4+4
        .equ    XR6,XR5+4
        .equ    XR7,XR6+4
        .equ    XR8,XR7+4
        .equ    XR9,XR8+4
        .equ    XR10,XR9+4
        .equ    XR11,XR10+4
        .equ    XR12,XR11+4
        .equ    XR13,XR12+4
        .equ    XR14,XR13+4
        .equ    XR15,XR14+4
        .equ    XR16,XR15+4
        .equ    XR17,XR16+4
        .equ    XR18,XR17+4
        .equ    XR19,XR18+4
        .equ    XR20,XR19+4
        .equ    XR21,XR20+4
        .equ    XR22,XR21+4
        .equ    XR23,XR22+4
        .equ    XR24,XR23+4
        .equ    XR25,XR24+4
        .equ    XR26,XR25+4
        .equ    XR27,XR26+4
        .equ    XR28,XR27+4
        .equ    XR29,XR28+4
        .equ    XR30,XR29+4
        .equ    XR31,XR30+4
        .equ    XMSR,XR31+4
        .equ    STACK_FRAME_SIZE,XMSR+4


	/* Make a dense file to avoid any possibilities of ambiguities
	in the ROM image. The fill pattern is 0xff to minimize wear and tear
	on the EEPROM. */
	
	.org 0x000	

	/* no vector, but put a zero to help catch null pointer errors*/
	.long 0	

	/* system reset vector */
	.org 0x100, 0xff
	b _start

	/* machine check */
	.org 0x200, 0xff
	b MachineCheckIntr
/*	rfi */
	
	/* external interrupt */
	.org 0x500, 0xff
	b ExternalIntr
/*	rfi */

	/* decrementer interrupt */
	.org 0x900, 0xff
	b DecrementerIntr
/*	rfi */

	/* trace */
	.org 0Xd00, 0xff
	b TraceIntr
/*	rfi */

	/* fill right up to the end of the table. */
	.org 0x1000, 0xff	



MachineCheckIntr:
#Save context
	stwu	%r1,-STACK_FRAME_SIZE(%r1)
	stw		%r0,XR0(%r1)
	mfspr	%r0,%LR
	stw		%r0,XLR(%r1)
	mfcr	%r0
	stw		%r0,XCR(%r1)
	mfspr	%r0,%XER
	stw		%r0,XXER(%r1)
	mfspr	%r0,%CTR
	stw		%r0,XCTR(%r1)
	mfspr	%r0,%SRR1
	stw		%r0,XSRR1(%r1)
	mfspr	%r0,%SRR0
	stw		%r0,XSRR0(%r1)
	mfmsr	%r0
	stw		%r0,XMSR(1)
	stw		%r2,XR2(%r1)
	stw		%r3,XR3(%r1)
	stw		%r4,XR4(%r1)
	stw		%r5,XR5(%r1)
	stw		%r6,XR6(%r1)
	stw		%r7,XR7(%r1)
	stw		%r8,XR8(%r1)
	stw		%r9,XR9(%r1)
	stw		%r10,XR10(%r1)
	stw		%r11,XR11(%r1)
	stw		%r12,XR12(%r1)
	stw		%r13,XR13(%r1)
	stw		%r14,XR14(%r1)
	stw		%r15,XR15(%r1)
	stw		%r16,XR16(%r1)
	stw		%r17,XR17(%r1)
	stw		%r18,XR18(%r1)
	stw		%r19,XR19(%r1)
	stw		%r20,XR20(%r1)
	stw		%r21,XR21(%r1)
	stw		%r22,XR22(%r1)
	stw		%r23,XR23(%r1)
	stw		%r24,XR24(%r1)
	stw		%r25,XR25(%r1)
	stw		%r26,XR26(%r1)
	stw		%r27,XR27(%r1)
	stw		%r28,XR28(%r1)
	stw		%r29,XR29(%r1)
	stw		%r30,XR30(%r1)
	stw		%r31,XR31(%r1)

	/* Set MSR[RI] bit so that breakpoints can be set, for instance */
	mtspr 81, %r3 #mtspr EID, r3

        lis 11,machine_check_interrupt_routine@ha
        lwz 9,machine_check_interrupt_routine@l(11)
#        lwz 29,0(9)
#        mtlr 29
        mtlr 9
        blrl

	lwz		%r2,XR2(%r1)
	lwz		%r3,XR3(%r1)
	lwz		%r4,XR4(%r1)
	lwz		%r5,XR5(%r1)
	lwz		%r6,XR6(%r1)
	lwz		%r7,XR7(%r1)
	lwz		%r8,XR8(%r1)
	lwz		%r9,XR9(%r1)
	lwz		%r10,XR10(%r1)
	lwz		%r11,XR11(%r1)
	lwz		%r12,XR12(%r1)
	lwz		%r13,XR13(%r1)
	lwz		%r14,XR14(%r1)
	lwz		%r15,XR15(%r1)
	lwz		%r16,XR16(%r1)
	lwz		%r17,XR17(%r1)
	lwz		%r18,XR18(%r1)
	lwz		%r19,XR19(%r1)
	lwz		%r20,XR20(%r1)
	lwz		%r21,XR21(%r1)
	lwz		%r22,XR22(%r1)
	lwz		%r23,XR23(%r1)
	lwz		%r24,XR24(%r1)
	lwz		%r25,XR25(%r1)
	lwz		%r26,XR26(%r1)
	lwz		%r27,XR27(%r1)
	lwz		%r28,XR28(%r1)
	lwz		%r29,XR29(%r1)
	lwz		%r30,XR30(%r1)
	lwz		%r31,XR31(%r1)
	lwz		%r0,XLR(%r1)
	mtspr	%LR,%r0
	lwz		%r0,XCR(%r1)
	mtcrf	255,%r0
	lwz		%r0,XXER(%r1)
	mtspr	%XER,%r0
	lwz		%r0,XCTR(%r1)
	mtspr	%CTR,%r0
	lwz		%r0,XSRR1(%r1)
	mtspr	%SRR1,%r0
	lwz		%r0,XSRR0(%r1)
	mtspr	%SRR0,%r0
	lwz		%r0,XMSR(%r1)
	mtmsr	%r0
	lwz		%r0,XR0(%r1)
	addi	%r1,%r1,STACK_FRAME_SIZE
	rfi

ExternalIntr:
#Save context
	stwu	%r1,-STACK_FRAME_SIZE(%r1)
	stw		%r0,XR0(%r1)
	mfspr	%r0,%LR
	stw		%r0,XLR(%r1)
	mfcr	%r0
	stw		%r0,XCR(%r1)
	mfspr	%r0,%XER
	stw		%r0,XXER(%r1)
	mfspr	%r0,%CTR
	stw		%r0,XCTR(%r1)
	mfspr	%r0,%SRR1
	stw		%r0,XSRR1(%r1)
	mfspr	%r0,%SRR0
	stw		%r0,XSRR0(%r1)
	mfmsr	%r0
	stw		%r0,XMSR(1)
	stw		%r2,XR2(%r1)
	stw		%r3,XR3(%r1)
	stw		%r4,XR4(%r1)
	stw		%r5,XR5(%r1)
	stw		%r6,XR6(%r1)
	stw		%r7,XR7(%r1)
	stw		%r8,XR8(%r1)
	stw		%r9,XR9(%r1)
	stw		%r10,XR10(%r1)
	stw		%r11,XR11(%r1)
	stw		%r12,XR12(%r1)
	stw		%r13,XR13(%r1)
	stw		%r14,XR14(%r1)
	stw		%r15,XR15(%r1)
	stw		%r16,XR16(%r1)
	stw		%r17,XR17(%r1)
	stw		%r18,XR18(%r1)
	stw		%r19,XR19(%r1)
	stw		%r20,XR20(%r1)
	stw		%r21,XR21(%r1)
	stw		%r22,XR22(%r1)
	stw		%r23,XR23(%r1)
	stw		%r24,XR24(%r1)
	stw		%r25,XR25(%r1)
	stw		%r26,XR26(%r1)
	stw		%r27,XR27(%r1)
	stw		%r28,XR28(%r1)
	stw		%r29,XR29(%r1)
	stw		%r30,XR30(%r1)
	stw		%r31,XR31(%r1)

	/* Set MSR[RI] bit so that breakpoints can be set, for instance */
	mtspr 81, %r3 #mtspr EID, r3

        lis 11,external_interrupt_routine@ha
        lwz 9,external_interrupt_routine@l(11)
#        lwz 29,0(9)
#        mtlr 29
        mtlr 9
        blrl

	lwz		%r2,XR2(%r1)
	lwz		%r3,XR3(%r1)
	lwz		%r4,XR4(%r1)
	lwz		%r5,XR5(%r1)
	lwz		%r6,XR6(%r1)
	lwz		%r7,XR7(%r1)
	lwz		%r8,XR8(%r1)
	lwz		%r9,XR9(%r1)
	lwz		%r10,XR10(%r1)
	lwz		%r11,XR11(%r1)
	lwz		%r12,XR12(%r1)
	lwz		%r13,XR13(%r1)
	lwz		%r14,XR14(%r1)
	lwz		%r15,XR15(%r1)
	lwz		%r16,XR16(%r1)
	lwz		%r17,XR17(%r1)
	lwz		%r18,XR18(%r1)
	lwz		%r19,XR19(%r1)
	lwz		%r20,XR20(%r1)
	lwz		%r21,XR21(%r1)
	lwz		%r22,XR22(%r1)
	lwz		%r23,XR23(%r1)
	lwz		%r24,XR24(%r1)
	lwz		%r25,XR25(%r1)
	lwz		%r26,XR26(%r1)
	lwz		%r27,XR27(%r1)
	lwz		%r28,XR28(%r1)
	lwz		%r29,XR29(%r1)
	lwz		%r30,XR30(%r1)
	lwz		%r31,XR31(%r1)
	lwz		%r0,XLR(%r1)
	mtspr	%LR,%r0
	lwz		%r0,XCR(%r1)
	mtcrf	255,%r0
	lwz		%r0,XXER(%r1)
	mtspr	%XER,%r0
	lwz		%r0,XCTR(%r1)
	mtspr	%CTR,%r0
	lwz		%r0,XSRR1(%r1)
	mtspr	%SRR1,%r0
	lwz		%r0,XSRR0(%r1)
	mtspr	%SRR0,%r0
	lwz		%r0,XMSR(%r1)
	mtmsr	%r0
	lwz		%r0,XR0(%r1)
	addi	%r1,%r1,STACK_FRAME_SIZE
	rfi

DecrementerIntr:
#Save context
	stwu	%r1,-STACK_FRAME_SIZE(%r1)
	stw		%r0,XR0(%r1)
	mfspr	%r0,%LR
	stw		%r0,XLR(%r1)
	mfcr	%r0
	stw		%r0,XCR(%r1)
	mfspr	%r0,%XER
	stw		%r0,XXER(%r1)
	mfspr	%r0,%CTR
	stw		%r0,XCTR(%r1)
	mfspr	%r0,%SRR1
	stw		%r0,XSRR1(%r1)
	mfspr	%r0,%SRR0
	stw		%r0,XSRR0(%r1)
	mfmsr	%r0
	stw		%r0,XMSR(1)
	stw		%r2,XR2(%r1)
	stw		%r3,XR3(%r1)
	stw		%r4,XR4(%r1)
	stw		%r5,XR5(%r1)
	stw		%r6,XR6(%r1)
	stw		%r7,XR7(%r1)
	stw		%r8,XR8(%r1)
	stw		%r9,XR9(%r1)
	stw		%r10,XR10(%r1)
	stw		%r11,XR11(%r1)
	stw		%r12,XR12(%r1)
	stw		%r13,XR13(%r1)
	stw		%r14,XR14(%r1)
	stw		%r15,XR15(%r1)
	stw		%r16,XR16(%r1)
	stw		%r17,XR17(%r1)
	stw		%r18,XR18(%r1)
	stw		%r19,XR19(%r1)
	stw		%r20,XR20(%r1)
	stw		%r21,XR21(%r1)
	stw		%r22,XR22(%r1)
	stw		%r23,XR23(%r1)
	stw		%r24,XR24(%r1)
	stw		%r25,XR25(%r1)
	stw		%r26,XR26(%r1)
	stw		%r27,XR27(%r1)
	stw		%r28,XR28(%r1)
	stw		%r29,XR29(%r1)
	stw		%r30,XR30(%r1)
	stw		%r31,XR31(%r1)

	/* Set MSR[RI] bit so that breakpoints can be set, for instance */
	mtspr 81, %r3 #mtspr EID, r3

        lis 11,decrementer_interrupt_routine@ha
        lwz 9,decrementer_interrupt_routine@l(11)
#        lwz 29,0(9)
#        mtlr 29
        mtlr 9
        blrl

	lwz		%r2,XR2(%r1)
	lwz		%r3,XR3(%r1)
	lwz		%r4,XR4(%r1)
	lwz		%r5,XR5(%r1)
	lwz		%r6,XR6(%r1)
	lwz		%r7,XR7(%r1)
	lwz		%r8,XR8(%r1)
	lwz		%r9,XR9(%r1)
	lwz		%r10,XR10(%r1)
	lwz		%r11,XR11(%r1)
	lwz		%r12,XR12(%r1)
	lwz		%r13,XR13(%r1)
	lwz		%r14,XR14(%r1)
	lwz		%r15,XR15(%r1)
	lwz		%r16,XR16(%r1)
	lwz		%r17,XR17(%r1)
	lwz		%r18,XR18(%r1)
	lwz		%r19,XR19(%r1)
	lwz		%r20,XR20(%r1)
	lwz		%r21,XR21(%r1)
	lwz		%r22,XR22(%r1)
	lwz		%r23,XR23(%r1)
	lwz		%r24,XR24(%r1)
	lwz		%r25,XR25(%r1)
	lwz		%r26,XR26(%r1)
	lwz		%r27,XR27(%r1)
	lwz		%r28,XR28(%r1)
	lwz		%r29,XR29(%r1)
	lwz		%r30,XR30(%r1)
	lwz		%r31,XR31(%r1)
	lwz		%r0,XLR(%r1)
	mtspr	%LR,%r0
	lwz		%r0,XCR(%r1)
	mtcrf	255,%r0
	lwz		%r0,XXER(%r1)
	mtspr	%XER,%r0
	lwz		%r0,XCTR(%r1)
	mtspr	%CTR,%r0
	lwz		%r0,XSRR1(%r1)
	mtspr	%SRR1,%r0
	lwz		%r0,XSRR0(%r1)
	mtspr	%SRR0,%r0
	lwz		%r0,XMSR(%r1)
	mtmsr	%r0
	lwz		%r0,XR0(%r1)
	addi	%r1,%r1,STACK_FRAME_SIZE
	rfi

TraceIntr:
#Save context
	stwu	%r1,-STACK_FRAME_SIZE(%r1)
	stw		%r0,XR0(%r1)
	mfspr	%r0,%LR
	stw		%r0,XLR(%r1)
	mfcr	%r0
	stw		%r0,XCR(%r1)
	mfspr	%r0,%XER
	stw		%r0,XXER(%r1)
	mfspr	%r0,%CTR
	stw		%r0,XCTR(%r1)
	mfspr	%r0,%SRR1
	stw		%r0,XSRR1(%r1)
	mfspr	%r0,%SRR0
	stw		%r0,XSRR0(%r1)
	mfmsr	%r0
	stw		%r0,XMSR(1)
	stw		%r2,XR2(%r1)
	stw		%r3,XR3(%r1)
	stw		%r4,XR4(%r1)
	stw		%r5,XR5(%r1)
	stw		%r6,XR6(%r1)
	stw		%r7,XR7(%r1)
	stw		%r8,XR8(%r1)
	stw		%r9,XR9(%r1)
	stw		%r10,XR10(%r1)
	stw		%r11,XR11(%r1)
	stw		%r12,XR12(%r1)
	stw		%r13,XR13(%r1)
	stw		%r14,XR14(%r1)
	stw		%r15,XR15(%r1)
	stw		%r16,XR16(%r1)
	stw		%r17,XR17(%r1)
	stw		%r18,XR18(%r1)
	stw		%r19,XR19(%r1)
	stw		%r20,XR20(%r1)
	stw		%r21,XR21(%r1)
	stw		%r22,XR22(%r1)
	stw		%r23,XR23(%r1)
	stw		%r24,XR24(%r1)
	stw		%r25,XR25(%r1)
	stw		%r26,XR26(%r1)
	stw		%r27,XR27(%r1)
	stw		%r28,XR28(%r1)
	stw		%r29,XR29(%r1)
	stw		%r30,XR30(%r1)
	stw		%r31,XR31(%r1)

	/* Set MSR[RI] bit so that breakpoints can be set, for instance */
	mtspr 81, %r3 #mtspr EID, r3

        lis 11,trace_interrupt_routine@ha
        lwz 9,trace_interrupt_routine@l(11)
#        lwz 29,0(9)
#        mtlr 29
        mtlr 9
        blrl

	lwz		%r2,XR2(%r1)
	lwz		%r3,XR3(%r1)
	lwz		%r4,XR4(%r1)
	lwz		%r5,XR5(%r1)
	lwz		%r6,XR6(%r1)
	lwz		%r7,XR7(%r1)
	lwz		%r8,XR8(%r1)
	lwz		%r9,XR9(%r1)
	lwz		%r10,XR10(%r1)
	lwz		%r11,XR11(%r1)
	lwz		%r12,XR12(%r1)
	lwz		%r13,XR13(%r1)
	lwz		%r14,XR14(%r1)
	lwz		%r15,XR15(%r1)
	lwz		%r16,XR16(%r1)
	lwz		%r17,XR17(%r1)
	lwz		%r18,XR18(%r1)
	lwz		%r19,XR19(%r1)
	lwz		%r20,XR20(%r1)
	lwz		%r21,XR21(%r1)
	lwz		%r22,XR22(%r1)
	lwz		%r23,XR23(%r1)
	lwz		%r24,XR24(%r1)
	lwz		%r25,XR25(%r1)
	lwz		%r26,XR26(%r1)
	lwz		%r27,XR27(%r1)
	lwz		%r28,XR28(%r1)
	lwz		%r29,XR29(%r1)
	lwz		%r30,XR30(%r1)
	lwz		%r31,XR31(%r1)
	lwz		%r0,XLR(%r1)
	mtspr	%LR,%r0
	lwz		%r0,XCR(%r1)
	mtcrf	255,%r0
	lwz		%r0,XXER(%r1)
	mtspr	%XER,%r0
	lwz		%r0,XCTR(%r1)
	mtspr	%CTR,%r0
	lwz		%r0,XSRR1(%r1)
	mtspr	%SRR1,%r0
	lwz		%r0,XSRR0(%r1)
	mtspr	%SRR0,%r0
	lwz		%r0,XMSR(%r1)
	mtmsr	%r0
	lwz		%r0,XR0(%r1)
	addi	%r1,%r1,STACK_FRAME_SIZE
	rfi

	.end


