// $Id: TouCAN_driver.h,v 1.1 2005/02/17 19:56:05 garthz Exp $
//
// TouCAN_driver.c : simple driver for a TouCAN module on a MPC5xx microcontroller.
//
// Copyright (C) 2004 Garth Zeglin.  Provided under the terms of the
// GNU General Public License.
//
// Please see TouCAN_driver.c for the assumptions this code makes, and
// documentation of the functions.
#ifndef _TOUCAN_DRIVER_H_INCLUDED_
#define _TOUCAN_DRIVER_H_INCLUDED_

// Use the Motorola hardware definition, which provides a lot of unions 
// to represent the registers.
#include <Motorola/m_toucan.h>

extern void TouCAN_init( struct TOUCAN_tag *toucan );

// Set the bus rate.  Normally this occurs after TouCAN_init(), and before
// TouCAN_turn_on().
typedef enum { CAN_BUS_INVALID_RATE, CAN_BUS_1MHZ, CAN_BUS_500KHZ } TouCAN_rate_t;
extern void TouCAN_set_rate( struct TOUCAN_tag *toucan, TouCAN_rate_t rate );

extern void TouCAN_activate_receive_buffer( struct TOUCAN_tag *toucan, 
					    unsigned short buffer, 
					    unsigned short identifier );

extern void TouCAN_turn_on( struct TOUCAN_tag *toucan );

extern void TouCAN_send_message( struct TOUCAN_tag *toucan, 
				 unsigned short buffer, 
				 unsigned short identifier,
				 unsigned short length, void *data);

extern int TouCAN_read_receive_buffer( struct TOUCAN_tag *toucan,
				       unsigned short buffer,
				       unsigned short *length_ptr,
				       unsigned short *identifier_ptr,
				       unsigned short *timestamp_ptr,
				       void *data );

extern unsigned short TouCAN_read_buffer_flag( struct TOUCAN_tag *toucan,
					       unsigned short buffer );


#endif  // _TOUCAN_DRIVER_H_INCLUDED_
