#ifndef _MPC566EVB_H_DEFINED_
#define _MPC566EVB_H_DEFINED_

#ifndef UINT32
#include <Motorola/m_common.h>  // for integer types
#endif

// This should really be in the newlib configuration.
#ifndef BIG_ENDIAN
#define BIG_ENDIAN 4321
#endif

#ifndef BYTE_ORDER
#define BYTE_ORDER BIG_ENDIAN
#endif


//================================================================
// Some information about the configuration.

// #define SYSTEM_CLOCK     20000000             // in Hz
#define SYSTEM_CLOCK     40000000             // in Hz
#define DECREMENTER_RATE  1000000             // in Hz  // This depends on the current time base clock init code.
#define TPU_CLOCK_RATE    (SYSTEM_CLOCK / 32) // in Hz  // This depends on the current TPU init code.

// Memory map
#define MPC566EVB_C3F_FLASH_BASE 0x00000000         // two internal MPC566 UC3F flash arrays
#define MPC566EVB_C3F_FLASH_SIZE 0x00100000         // 1 M in two 512K segments
#define MPC566EVB_SRAM_BASE      0x01000000
#define MPC566EVB_SRAM_SIZE      0x00100000         // size in bytes
#define MPC566EVB_STD_FLASH_BASE 0x02000000
#define MPC566EVB_STD_FLASH_SIZE 0x00100000         // size in bytes

#define MPC566EVB_ETHERNET_BASE  0x03000000

//================================================================
// Initialize some hardware.  This should only be called once.
extern void mpc566evb_init(void);

// Initialize the serial port.
//  qsmcm = 0 for QSMCM_A, 1 for QSMCM_B
//  sci = 0 for SCI1, 1 for SCI2
extern void mpc566evb_init_serial( int qsmcm, int sci );

//Turn an LED attached to GPIO0 on or off
void mpc566evb_set_LED(int flag);

//================================================================
#endif
