#ifndef _MPC566EVB_FLASH_H_DEFINED_
#define _MPC566EVB_FLASH_H_DEFINED_

// Currently, there isn't much error handling in this
// code. Eventually, there could be a set of "verify" routines.

// Reset the flash chip state machine.
extern void mpc566evb_flash_reset(void);

// Erase the safe "user" portion of the flash not containing the dBUG monitor
// Probably takes longer than a full chip erase due to command overhead
void mpc566evb_flash_erase_all_user(void);

// Erase the entire chip.  This can take a while. First test: about 20 seconds.
extern void mpc566evb_flash_erase_all(void);

// Erase a single sector, given an address within that sector.
extern void mpc566evb_flash_erase_sector(unsigned int *address);

// Program a 32 bit word into FLASH at the specified address. The
// address is specified in the host address space, i.e., the actual
// address at which the word appears in the memory map, which
// typically begins at MPC566EVB_STD_FLASH_BASE.  
extern void mpc566evb_flash_write_word(unsigned int *Address, unsigned int value);

// Read ID code from the device.
// On my board, the manufacturer ID is 0x00000001 and the device ID is
// 0x0000007e (unconfirmed!).

extern unsigned int mpc566evb_flash_read_manuf_ID(void);
extern unsigned int mpc566evb_flash_read_device_ID(void);



#endif /* _MPC566EVB_FLASH_H_DEFINED_ */
