
#include "atomic.h"

int atomic_increment(int *loc, int increment)
{
  int oldval;
  int tmp;

    asm("
1:       lwarx  %0,0,%2;
         add    %1,%3,%0;
         stwcx. %1,0,%2;
         bne-   1b;"
        : "=&r" (oldval), "=&r" (tmp) /* outputs */
        : "r" (loc), "r" (increment) /* inputs */
        /* overwrites */
       );

  return oldval;
}

int atomic_compare_and_swap(int *loc, int testval, int newval)
{
  int result;
  int tmp;

    asm("
1:       lwarx  %1,0,%2;
         cmpw   %3,%1;
         bne    2f;
         stwcx. %4,0,%2;
         bne-   1b;
         li     %0,1;
         b      3f;
2:       li     %0,0;
3:      "
        : "=&r" (result), "=&r" (tmp) /* outputs */
        : "r" (loc), "r" (testval), "r" (newval) /* inputs */
        /* overwrites */
       );

  return result;
}

