#ifndef MPC5XX_ATOMIC_H
#define MPC5XX_ATOMIC_H

/*
 * Atomically increment the value stored at loc by a supplied increment
 * The value previously stored at loc is returned
 */
int atomic_increment(int *loc, int increment);

/*
 * Compare the value stored at loc with a supplied value (testval)
 * If these match, atomically (within the same timeslice as the comparison)
 *   replace the value stored at loc with the supplied new value (newval)
 * Returns 1 if the comparison matched (and thus the swap took place)
 *   or 0 otherwise
 */
int atomic_compare_and_swap(int *loc, int testval, int newval);


#endif /* MPC5XX_ATOMIC_H */

