
#include "memutils.h"

/****************************************************************/
// Assume that we are running from ROM, and copy the initialized data
// from the load address in the ROM image to the relocation address in
// RAM.  This assumes that the memory controller has already been
// initialized so that the RAM is actually available.

extern unsigned char _data_section_rom_start, _data_section_ram_start, _data_section_ram_end;

void initialize_data_section(void)
{
  register unsigned char *src = &_data_section_rom_start;
  register unsigned char *dst = &_data_section_ram_start;
  register unsigned char *limit = &_data_section_ram_end;

  // copy initialized data from ROM area.
  while ( dst < limit )  *dst++ = *src++;
}
