
#include "interruptcontroller.h"

// [IRQ0]...[IRQ7]
// [^MSB]...[^LSB]
void mpc5xx_set_external_interrupt_level_mask(char mask)
{
  USIU.SIMASK.B.LVM0 = (mask >> 7) & 1;
  USIU.SIMASK.B.LVM1 = (mask >> 6) & 1;
  USIU.SIMASK.B.LVM2 = (mask >> 5) & 1;
  USIU.SIMASK.B.LVM3 = (mask >> 4) & 1;
  USIU.SIMASK.B.LVM4 = (mask >> 3) & 1;
  USIU.SIMASK.B.LVM5 = (mask >> 2) & 1;
  USIU.SIMASK.B.LVM6 = (mask >> 1) & 1;
  USIU.SIMASK.B.LVM7 = (mask >> 0) & 1;
}

void mpc5xx_enable_external_interrupt_level(int level)
{
  switch (level) {
    case 0:
      USIU.SIMASK.B.LVM0 = 1;
      break;
    case 1:
      USIU.SIMASK.B.LVM1 = 1;
      break;
    case 2:
      USIU.SIMASK.B.LVM2 = 1;
      break;
    case 3:
      USIU.SIMASK.B.LVM3 = 1;
      break;
    case 4:
      USIU.SIMASK.B.LVM4 = 1;
      break;
    case 5:
      USIU.SIMASK.B.LVM5 = 1;
      break;
    case 6:
      USIU.SIMASK.B.LVM6 = 1;
      break;
    case 7:
      USIU.SIMASK.B.LVM7 = 1;
      break;
    default:
      //unknown level!
      break;
  }
}

void mpc5xx_disable_external_interrupt_level(int level)
{
  switch (level) {
    case 0:
      USIU.SIMASK.B.LVM0 = 0;
      break;
    case 1:
      USIU.SIMASK.B.LVM1 = 0;
      break;
    case 2:
      USIU.SIMASK.B.LVM2 = 0;
      break;
    case 3:
      USIU.SIMASK.B.LVM3 = 0;
      break;
    case 4:
      USIU.SIMASK.B.LVM4 = 0;
      break;
    case 5:
      USIU.SIMASK.B.LVM5 = 0;
      break;
    case 6:
      USIU.SIMASK.B.LVM6 = 0;
      break;
    case 7:
      USIU.SIMASK.B.LVM7 = 0;
      break;
    default:
      //unknown level!
      break;
  }
}

