#ifndef MPC5XX_INTERRUPTS_H
#define MPC5XX_INTERRUPTS_H

typedef enum {MPC5XX_MACHINE_CHECK_INTR,
              MPC5XX_EXTERNAL_INTR,
              MPC5XX_DECREMENTER_INTR,
              MPC5XX_TRACE_INTR } mpc5xx_interrupt_t;

/*** Symbols defined in the flash monitor ***/

extern void (*machine_check_interrupt_routine)();
extern void (*external_interrupt_routine)();
extern void (*decrementer_interrupt_routine)();
extern void (*trace_interrupt_routine)();
extern void null_interrupt_handler();

/*** Symbols defined in interrupts.c ***/
extern int mpc5xx_install_interrupt_handler(mpc5xx_interrupt_t type,
                                     void(*fn)());
void mpc5xx_install_default_interrupt_handlers();

//return MSR[EE]
int mpc5xx_ext_interrupts_enabled();

void mpc5xx_enable_external_interrupts();
void mpc5xx_disable_external_interrupts();

#endif /* MPC5XX_INTERRUPTS_H */

