#ifndef MPC5XX_INTERRUPTUTILS_H
#define MPC5XX_INTERRUPTUTILS_H

typedef struct {
  void (*fn)(void*);
  void *fnarg;
  int id; //set by the interruptutils functions
          //unique ID number of handler (modulo 2^32 wraparound)
  int index; //internal data for interruptutils functions for efficiency
             //must not be modified by user applications
} interrupt_handler_t;

/*** Internal structure for interruptutils.c ***/

typedef struct {
  void (*fn)(void*);
  void *fnarg;
  int used; //0 => unused, 1 => used, -1 => locked (adding/removing)
  int valid; //0 => invalid, 1 => valid
  int id; //id number [1,255] or -1 if none (i.e., not yet used)
} interrupt_handler_data_t;

#define MAX_INTERRUPT_HANDLERS 8

void mpc5xx_init_ext_interrupts();
void mpc5xx_disable_ext_interrupts();
int mpc5xx_add_ext_interrupt_handler(interrupt_handler_t *hdlr);
int mpc5xx_remove_ext_interrupt_handler(interrupt_handler_t *hdlr);


#endif /* MPC5XX_INTERRUPTUTILS_H */

