
#include "misc.h"

/****************************************************************/
UINT32 mpc5xx_read_IMMR(void)
{
  UINT32 value;

  // Read and return the IMMR register, SPR 638.  The extended
  // expression is GCC specific for returning a result in a particular
  // C value. This can be interpreted as follows:
  // 
  //   mfspr  "move from special purpose register"
  //   %0  handle for destination register
  //   638 source address (IMMR register)
  //   "=r" ((value)) place value %0 in C location "value"  
  //       the '=' indicates output



  asm("mfspr %0, 638" : "=r" ((value)));  

  return value;
}

