#ifndef MPC5XX_MISC_H
#define MPC5XX_MISC_H

#ifndef UINT32
#include <Motorola/m_common.h>  // for integer types
#endif

//================ General MPC5xx utility functions =====================
// Read the IMMR, Internal Memory Map Register.
// The fields are as follows
// names:  PARTNUM : MASKNUM : RESERVED : FLEN : RESERVED : RESERVED : RESERVED : ISB : 0
// widths:      8       8         4         1       2           1         4        3    1
//
// Define a few masks for the value:
#define MPC5XX_IMMR_PARTNUM_MASK   (0xff000000)
#define MPC5XX_IMMR_MASKNUM_MASK   (0x00ff0000)
#define MPC5XX_IMMR_FLEN_MASK      (0x00000800)    // enables the internal flash (1 == enabled)
#define MPC5XX_IMMR_ISB_MASK       (0x0000000e)    // base address of internal registers = (ISB * 0x40000)

UINT32 mpc5xx_read_IMMR(void);

#define mpc5xx_reboot() ((void(*)())0x100)()

#endif /* MPC5XX_MISC_H */

