
#include <Motorola/m_qsmcm.h>
#include "serialinterrupts.h"

//level \in [0,31]
int set_serial_interrupt_level(struct QSMCM_tag *qsmcm, int level)
{
  qsmcm->QDSCI_IL.B.ILDSCI = level;

  return 0;
}

int enable_serial_transmit_interrupts(struct QSMCM_tag *qsmcm, int sci)
{
  if (sci == 1) {
    qsmcm->SCC1R1.B.TIE = 1;
//    qsmcm->SCC1R1.B.TCIE = 1;
  }
  else if (sci == 2) {
    qsmcm->SCC2R1.B.TIE = 1;
//    qsmcm->SCC2R1.B.TCIE = 1;
  }
  else
    return -1;

  return 0;
}

int disable_serial_transmit_interrupts(struct QSMCM_tag *qsmcm, int sci)
{
  if (sci == 1) {
    qsmcm->SCC1R1.B.TIE = 0;
    qsmcm->SCC1R1.B.TCIE = 0;
  }
  else if (sci == 2) {
    qsmcm->SCC2R1.B.TIE = 0;
    qsmcm->SCC2R1.B.TCIE = 0;
  }
  else
    return -1;

  return 0;
}

int enable_serial_receive_interrupts(struct QSMCM_tag *qsmcm, int sci)
{
  if (sci == 1) {
    qsmcm->SCC1R1.B.RIE = 1;
  }
  else if (sci == 2) {
    qsmcm->SCC2R1.B.RIE = 1;
  }
  else
    return -1;

  return 0;
}

int disable_serial_receive_interrupts(struct QSMCM_tag *qsmcm, int sci)
{
  if (sci == 1) {
    qsmcm->SCC1R1.B.RIE = 0;
  }
  else if (sci == 2) {
    qsmcm->SCC2R1.B.RIE = 0;
  }
  else
    return -1;

  return 0;
}

int disable_serial_interrupts(struct QSMCM_tag *qsmcm, int sci)
{
  if (sci == 1) {
    qsmcm->SCC1R1.B.TIE = 0;
    qsmcm->SCC1R1.B.TCIE = 0;
    qsmcm->SCC1R1.B.RIE = 0;
  }
  else if (sci == 2) {
    qsmcm->SCC2R1.B.TIE = 0;
    qsmcm->SCC2R1.B.TCIE = 0;
    qsmcm->SCC2R1.B.RIE = 0;
  }
  else
    return -1;

  return 0;
}

