

#include "timestamps.h"

/****************************************************************/
// Read the decrementer register.  It is discussed in Section 6.7 of
// the User's Manual.  It counts down at a fraction of the system
// clock.

UINT32 mpc5xx_read_DEC(void)
{
  UINT32 value;

  // Read and return the DEC (decrementer) register, SPR 22.  The extended
  // expression is GCC specific for returning a result in a particular
  // C value. This can be interpreted as follows:
  // 
  //   mfspr  "move from special purpose register"
  //   %0  handle for destination register
  //   22 source address (DEC register)
  //   "=r" ((value)) place value %0 in C location "value"  
  //       the '=' indicates output

  asm("mfspr %0, 22" : "=r" ((value)));  
  return value;
}  
/****************************************************************/
// Read the 64-bit Time Base register.  It is discussed in section 6.8 of the User's Manual.

#if 0
unsigned long long mpc5xx_read_TB(void)
{
  UINT32 low_value, high_value;
  asm("mftb %0" : "=r" ((low_value)));    
  asm("mftbu %0" : "=r" ((high_value)));
  return ((unsigned long long) low_value) | (((unsigned long long) high_value) << 32);
}
#endif
/****************************************************************/
