
#include <Motorola/m_tpu3.h>
#include "tpu_interrupts.h"

/* This overlaps somewhat with Motorola's mpc500_util.c */

void mpc5xx_set_tpu_interrupt_level(struct TPU3_tag *tpu, int level)
{
  tpu->TICR.B.CIRL = level & 7;
  tpu->TICR.B.ILBS = (level & 24) >> 3;
}

void mpc5xx_enable_tpu_channel_interrupts(struct TPU3_tag *tpu, int chan)
{
  tpu->CIER.R |= 1 << chan;
}

void mpc5xx_disable_tpu_channel_interrupts(struct TPU3_tag *tpu, int chan)
{
  tpu->CIER.R &= ~(1 << chan);
}

void mpc5xx_set_tpu_channel_interrupts(struct TPU3_tag *tpu, int chan, int setting)
{
  tpu->CIER.R &= ~(1 << chan) | (!!setting << chan);
}

