#include <errno.h>

/* Symbols defined in the linker scripts. */
extern unsigned char _heap_start, _heap_end;

/* These pointers are stored as initialized global variables so they
   have reasonable defaults but can be changed at run-time. 
   These are the pointers to the remaining unallocated space, not
   yet handed over to malloc and the like. */

unsigned char *sbrk_heap_start = &_heap_start;
unsigned char *sbrk_heap_end   = &_heap_end;

/*
 * sbrk -- changes heap size size. Get nbytes more
 *         RAM. We just increment a pointer in what's
 *         left of memory on the board.
 */
void *
sbrk (int nbytes )
{
  unsigned char *base = sbrk_heap_start;
  if ( base + nbytes < sbrk_heap_end ) {
    sbrk_heap_start += nbytes;
    return (void *) base;
  } else {
    errno = ENOMEM;
    return ((void *)-1);
  }
}


