
#include <Motorola/mpc565.h>
#include <mpc5xx/memutils.h>

//Before the DPTRAM can be used, the DPTRAM RAM Base Address Register (RAMBAR)
//  must be intialized with the proper value (which is hard-specified in
//  section 19.3.3 of the reference manual)

//The MPC565 has two DPTRAM regions:
//  0x301000 -- 0x301FFF => 4kb DPTRAM_C (for TPU C)
//  0x302000 -- 0x3037FF => 6kb DPTRAM_AB (for TPUs A and B)

//Either (or both) of these regions can be used as general purpose memory
//  as long as neither of the corresponding TPUs is in emulation mode
//  (by default a TPU is not in emulation mode)

void configure_dptram()
{
  DPTRAM4K.RAMBAR.R = 0xFF90;
  DPTRAM6K.RAMBAR.R = 0xFFA0;
}

