#ifndef _PHYCORE_MPC565_FLASH_H_DEFINED_
#define _PHYCORE_MPC565_FLASH_H_DEFINED_

// Currently, there isn't much error handling in this
// code. Eventually, there could be a set of "verify" routines.

// Reset the flash chip state machine.
extern void phyCORE_MPC565_flash_reset(void);

// Erase the entire chip.  This can take a while. First test: about 20 seconds.
extern void phyCORE_MPC565_flash_erase_all(void);

// Erase a single sector, given an address within that sector.
extern void phyCORE_MPC565_flash_erase_sector(unsigned int *address);

// Program a 32 bit word into FLASH at the specified address. The
// address is specified in the host address space, i.e., the actual
// address at which the word appears in the memory map, which
// typically begins at PHY_STD_FLASH_BASE.  
extern void phyCORE_MPC565_flash_write_word(unsigned int *Address, unsigned int value);

// Read ID codes from both upper and lower devices simultaneously.  On
// my board, the manufacturer ID is 0x00010001 and the device ID is
// 0x22da22da.

extern unsigned int phyCORE_MPC565_flash_read_manuf_ID(void);
extern unsigned int phyCORE_MPC565_flash_read_device_ID(void);



#endif /* _PHYCORE_MPC565_FLASH_H_DEFINED_ */
