
#include <stdio.h>
#include <Motorola/mpc566.h>
#include <Motorola/mpc500_util.h>
#include <mpc566evb/mpc566evb.h>
#include <mpc5xx/memutils.h>
#include <mpc5xx/microseconds.h>
#include <mpc5xx/timestamps.h>
#include <serial.h>
#include <stdlib.h>

int main()
{
  char c;

#ifdef DEBUG_AND_ROM_LIBRARY /* This program uses ROM symbols but is executed via
                                the BDM */
  init_hw();  // Initialize the ROM monitor (set up hardware, initialize data areas)
  clear_bss_section();
  enable_external_heap();      // Reset sbrk to use the available external RAM.
  use_default_serial_port();
#else
#ifdef USE_ROM_LIBRARY /* This program uses ROM symbols and is executed after
                                the flash monitor initializes (i.e., executed
                                by the flash monitor) */
  clear_bss_section();
  enable_external_heap();
  use_default_serial_port();
#else /* This program doesn't reference ROM symbols */
  mpc566evb_init();        // initialize the memory controller, etc.
  clear_bss_section();
  enable_external_heap();
  mpc566evb_init_serial( 0, 0 );  // Set up QSMCM_A SCI1
  use_default_serial_port();
#endif /* USE_ROM_LIBRARY */
#endif /* DEBUG_AND_ROM_LIBRARY */

  printf("Hello World!\n");

  printf("\n\n");

  printf("Hit 'q' to restart\n");

  while (1) {
    while(kbhit());
    c = GetSByte();
    if (c == 'q' || c == 'Q')
      ((void(*)())0x100) (); //jump to reset vector
  }


  return 0;
}

