
#include <stdio.h>
#include <string.h>
#include <errno.h>

#define SERIAL_PORT "/dev/ttyS0"

int main(int argc, char **argv)
{
  FILE *infile;
  FILE *portin;
  FILE *portout;
  char line[256];
  char c;
  int byteswritten = 0;

  if (argc < 2) {
    printf("Usage: %s <filename>\n", argv[0]);
    printf("  Upload <filename> to the serial port\n");
    exit(1);
  }

  if ((infile = fopen(argv[1], "r")) == NULL) {
    printf("Error opening file %s: %s\n", argv[1], strerror(errno));
    exit(1);
  }

  if ((portin = fopen(SERIAL_PORT, "r")) == NULL) {
    printf("Error opening port %s: %s\n", SERIAL_PORT, strerror(errno));
    exit(1);
  }

  if ((portout = fopen(SERIAL_PORT, "a")) == NULL) {
    printf("Error opening port %s: %s\n", SERIAL_PORT, strerror(errno));
    exit(1);
  }

  if (fgets(line, sizeof(line), infile) == NULL) {
    printf("Short file read.  No bytes written.\n");
    exit(0);
  }

  if (fputs(line, portout) < 0) {
    printf("Error writing first line\n");
    exit(1);
  }

  byteswritten += strlen(line);

  while (fgets(line, sizeof(line), infile) != NULL) {
    printf("\rBytes written: %d", byteswritten);
    if ((c = (unsigned char)fgetc(portin)) != '.') {
      printf("\nError: '%c' received instead of '.'\n", c);
      fclose(infile);
      fclose(portin);
      fclose(portout);
      exit(1);
    }
    if (fputs(line, portout) < 0) {
      printf("\nError writing line\n");
      fclose(infile);
      fclose(portin);
      fclose(portout);
      exit(1);
    }
    byteswritten += strlen(line);
  }

  printf("\n");
  printf("Finished successfully.\n");

  fclose(infile);
  fclose(portin);
  fclose(portout);

  return 0;
}


